(function() {
  var vm = new Vue({
    el: "body",
    data: {
      banners: [],
      news: [],
      if_login: false,
      services: [],
      extras: [],
      phone: null,
      name: null,
      mostCommon: {
        title: "日常保洁",
        id: 1
      }
    },
    methods: {
      openExtraDetail: function(i) {
        _openWindow("extra", i.extraUrl);
      },
      openBanner: function(id) {
        _callAjax({
          cmd: "fetch",
          sql: "select * from newsInfo where id = "+id
        }, function(d) {
          if (d.success) {
            _openWindow("detail", modules["detail.html"], {
              news: d.data[0]
            });
          }
        })
      },
      openDetail: function(news) {
        _openWindow("detail", modules["detail.html"], {
          news: news
        });
      },
      userCtrl: function() {
        var self = this;
        if (this.if_login) {
          mui.confirm("确定退出？", "提示", ["确定", "取消"], function(e) {
            if (!e.index) {
              plus.storage.setItem("phone", "");
              self.if_login = false;
              _openWindow("signin", modules["signin.html" ]);
            }
          });
        } else {
          _openWindow("signin", modules["signin.html"]);
        }
      },
      needRepair: function() {
        if (!this.if_login) {
          mui.confirm("尚未登陆，是否现在登陆？", "提示", ["确定", "取消"], function(e) {
            if (!e.index) {
              _openWindow("signin", modules["signin.html"]);
            }
          });
        } else {
          _openWindow("service", this.mostCommon.serviceUrl, {
            // service: this.services[0] // 家政保洁
            service: this.mostCommon
          });
        }
      },
      openServiceDetail: function(i) {
        mui("#popover").popover("hide");
        _openWindow("housekeepDetail", modules["housekeep-detail.html"], {
          service: i
        });
      },
      openAppliancesCleaning: function() {
        var self = this;
        _openWindow("housekeepDetail", modules["housekeep-detail.html"], {
          service: self.services.filter(function(r) {
            return r.id == 10;
          })[0]
        });
      },
      openBusinessPlan: function() {
        var self = this;
        _openWindow("housekeepDetail", modules["housekeep-detail.html"], {
          service: self.services.filter(function(r) {
            return r.id == 11;
          })[0]
        });
      }
//    openRecord: function() {
//      _openWindow("record", "record.html");
//    }
    }
  });

  window.addEventListener("updateIfLogin", function(evt) {
    vm.if_login = evt.detail.if_login;
    vm.phone = plus.storage.getItem("phone");
    vm.name = plus.storage.getItem("name");
  });

  var modules = {};

  mui.plusReady(function() {
    vm.phone = plus.storage.getItem('phone');
    vm.name = plus.storage.getItem('name');
    modules = JSON.parse(plus.storage.getItem("modules"));

    if (!!vm.phone) {
      vm.if_login = true;
    }

    var multis = [
      {
        key: "news",
        sql: "select * from newsInfo order by id desc limit "+news_limit
      },
      {
        key: "banners",
        sql: "select b.id, b.img, b.newsId, n.title from bannerAdmin b, newsInfo n where b.newsId = n.id order by b.id desc limit 5"
      },
      {
        key: "services",
        sql: "select * from housekeeps where ifValid = 1"
      },
      {
        key: "extras",
        sql: "select * from extras where ifValid = 1"
      }
    ];
    if (vm.if_login) {
      multis.push({
        key: "mostCommon",
        sql: "select r.id, h.id, h.img, h.title, h.brief, h.introduction, h.services, h.serviceUrl, count(r.id) as cnt from repairRecord r, housekeeps h where r.userPhone = '"+vm.phone+"' and h.id = r.serviceId order by cnt desc limit 1"
      });
    }

    _callAjax({
      cmd: "multiFetch",
      multi: JSON.stringify(multis)
    }, function(d) {
      if (!d.success) return mui.toast("无法获取信息");
      if (d.data.news.length) {
        vm.news = d.data.news;
      }
      if (d.data.banners.length) {
        var banners = [];
        d.data.banners.forEach(function(r) {
          r.img = addr+r.img;
          banners.push(r);
        });
        vm.banners = banners;
        vm.$nextTick(function() {
          mui("#slider").slider({
            interval: 3000
          });
        });
      }
      if (d.data.services.length) {
        vm.services = _map(d.data.services, function(r) {
          if (r.img) {
            r.img = addr + r.img;
          }
          return r;
        });
      }
      if (d.data.extras.length) {
        vm.extras = _map(d.data.extras, function(r) {
          r.img = addr + r.img;
          return r;
        });
      }

      // 最常用
      if (!!d.data['mostCommon'] && d.data.mostCommon.length && !!d.data.mostCommon[0].title) {
        vm.mostCommon = d.data.mostCommon[0];
      } else {
        vm.mostCommon = vm.services[0];
      }
    });

  });
}());
