(function() {
	var vm = new Vue({
		el: "body",
		data: {
			service: {},
			orderTag: "立即预约"
		},
		watch: {
			service: function(n) {
				if (n.serviceUrl.indexOf("tel") == 0) {
					this.orderTag = "电话预约";
				}
			}
		},
		methods: {
			openOrder: function() {
				var if_login = !!plus.storage.getItem("phone");
				if(!if_login) {
					mui.toast("请先到首页登录");
					return;
				}
				if (this.service.serviceUrl.indexOf("tel") == 0) {
					plus.device.dial(_at(this.service.serviceUrl.split(":"), -1), false);
				} else {
					_openWindow("service", this.service.serviceUrl, {
						service: this.service
					});
				}
			}
		}
	});

	mui.plusReady(function() {
		vm.service = plus.webview.currentWebview().service;

		//share
		var bhref = false,
			shares = null;

		//分享
		$('.share').on('tap', function() {
			/**
			 * 更新分享服务
			 */
			plus.share.getServices(function(s) {
				shares = {};
				for(var i in s) {
					var t = s[i];
					shares[t.id] = t;
//					alert(t.id)
				}

			}, function(e) {
				alert("获取分享服务列表失败：" + e.message);
			});
			var ids = [{
					id: "weixin",
					ex: "WXSceneSession"
				}, {
					id: "weixin",
					ex: "WXSceneTimeline"
				}],
				bts = [{
					title: "发送给微信好友"
				}, {
					title: "分享到微信朋友圈"
				}];
			plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: bts
				},
				function(e) {
					var i = e.index;
					if(i > 0) {
						shareAction(ids[i - 1].id, ids[i - 1].ex);
					}
				}
			);
			/**
			 * 分享操作
			 * @param {String} id
			 */
			function shareAction(id, ex) {
				var s = null;
				if(!id || !(s = shares[id])) {
					console.log("无效的分享服务！");
					return;
				}
				if(s.authenticated) {
					console.log("---已授权---");
					shareMessage(s, ex);
				} else {
					console.log("---未授权---");
					s.authorize(function() {
						shareMessage(s, ex);
					}, function(e) {
						alert("认证授权失败：" + e.code + " - " + e.message);
					});
				}
			}
			/**
			 * 发送分享消息
			 * @param {plus.share.ShareService} s
			 */

			function shareMessage(s, ex) {
				var title = $('.apponit-title').text();
				s.send(	{
					thumbs: '../img/logo.png',
					pictures: '../img/logo.png',
					title: '睿翔云家' + title,
					content:'content',
					href: app_addr+"share/index.html?serviceId="+vm.service.id,
					extra: {
						scene: ex
					}
					// href:'http://image.baidu.com/search/index?tn=baiduimage&ipn=r&ct=201326592&cl=2&lm=-1&st=-1&fr=&sf=1&fmq=1467797072950_R&pv=&ic=0&nc=1&z=&se=1&showtab=0&fb=0&width=&height=&face=0&istype=2&ie=utf-8&word=%E6%9D%8E%E5%85%8B%E5%BC%BA%E6%AD%A6%E6%B1%89%E7%8E%B0%E5%9C%BA%E6%8C%87%E6%8C%A5%E6%8A%A2%E9%99%A9%E6%95%91%E7%81%BE'
				}, function() {
					var phone = plus.storage.getItem("phone");
					if (!!phone) {
						_callAjax({
							cmd: "exec",
							sql: "insert into shares(phone, housekeepId) values('"+phone+"', "+vm.service.id+")"
						}, function(_d) {})
					}
					console.log("分享到\"" + s.description + "\"成功！ ");
				}, function(e) {
					console.log("分享到\"" + s.description + "\"失败: " + e.code + " - " + e.message);
				});
			}
		})
	});

}());
