(function() {
  var mask = mui.createMask();
  var vm = new Vue({
    el: "body",
    data: {
      records: []
    },
    methods: {
      showDetail: function(r) {
        if (!r.status) return mui.toast("该订单尚未完工");
        _openWindow("feedback", modules["record-feedback.html"], {
          record: r
        });
      }
    }
  });

  var fetchRecords = function() {
    _callAjax({
      cmd: "fetch",
      sql: "select h.title, rr.id, rr.userPhone, rr.address, rr.content, rr.img, rr.status, strftime('%Y-%m-%d %H:%M:%S', rr.logdate) as logdate from repairRecord rr, housekeeps h where h.id = rr.serviceId and userPhone = '"+plus.storage.getItem("phone")+"' and rr.status < 3 order by rr.id desc"
    }, function(d) {
      if (d.success && d.data && d.data.length) {
        var data = [];
        d.data.forEach(function(r) {
          r.status = parseInt(r.status);
          r.statusTag = ["已支付", "已完成", "已评价"][r.status];
          data.push(r);
        });
        vm.records = data;
      }
    });
  };

  window.addEventListener("fetchRecords", function() {
    fetchRecords();
  });

  var modules = {};

  mui.plusReady(function() {
    modules = JSON.parse(plus.storage.getItem("modules"));
    fetchRecords();
  });
}());
