(function() {
  var vm = new Vue({
    el: "body",
    data: {
      repairer: "请选择维修人员",
      repairerIdChoosed: -1,
      type: "请选择维修种类",
      price: 0,
      typeId: -1,
      img: "assets/img/img-upload.jpg",
      repairerPicker: null,
      servicePicker: null,
      content: "",
      location: ""
    },
    methods: {
      chooseRepairer: function() {
        if (!this.repairerPicker) return;
        var self = this;
        this.repairerPicker.show(function(items) {
  				self.repairer = items[0].text;
          self.repairerIdChoosed = items[0].value;
  			});
      },
      chooseType: function() {
        if (!this.servicePicker) return;
        var self = this;
        this.servicePicker.show(function(items) {
  				self.type = items[0].text;
          var eles = items[0].value.split("|");
          self.price = parseFloat(eles[0]);
          self.typeId = eles[1];
  			});
      },
      chooseImg: function() {
        var self = this;
        plus.gallery.pick(function(path) {
          self.img = path;
        }, function(e) {
          self.img = "assets/img/img-upload.jpg";
        });
      },
      uploadInfo: function() {
        var content = _trim(this.content),
          location = _trim(this.location),
          self = this;
        if (this.img == "assets/img/img-upload.jpg") return mui.toast("请上传图片");
        if (!content) return mui.toast("请填写维修内容");
        if (!location) return mui.toast("请填写地址");
        if (this.typeId < 0) return mui.toast("请选择服务种类");
        if (!this.repairerIdChoosed < 0) return mui.toast("请选择维修人员");
        var zip_name = _zipName(this.img);
        _zipImg(this.img, zip_name, 0.5, 0.2, function(f) {
          _uploadImg(addr+"/img", "suggest", f, function(t, status) {
            // alert(JSON.stringify(t));
            var im = JSON.parse(t.responseText).data;
            if (status == 200) {
              plus.io.resolveLocalFileSystemURL(f, function(entry) {
								entry.remove();
							});
              _callAjax({
                cmd: "exec",
                sql: "insert into repairRecord(userPhone, repairerId, address, content, img, serviceId) values("
                  + "'"+plus.storage.getItem("phone")+"', "
                  + self.repairerIdChoosed+", '"
                  + content + "', '"
                  + location + "', '"
                  + addr.slice(0, addr.length-1)+im + "', "
                  + self.typeId + ")"
              }, function(d) {
                mui.toast("上传"+(d.success?"成功":"失败"));
                plus.storage.setItem("location", location);
                _openWindow("record", "record.html");
              });
            } else {
              plus.nativeUI.closeWaiting();
							mui.toast("上传失败");
            }
          }, function() {
            plus.nativeUI.closeWaiting();
						mui.toast("压缩失败");
          });
        });
      }
    }
  });

  mui.plusReady(function() {
    mui.init();
    vm.repairerPicker = new mui.PopPicker();
    vm.servicePicker = new mui.PopPicker();
    vm.img = "assets/img/img-upload.jpg";

    var loc = plus.storage.getItem("location");
    if (!!loc) vm.location = loc;

    _callAjax({
      cmd: "fetch",
      sql: "select * from repairerInfo"
    }, function(d) {
      if (d.success && d.data && d.data.length) {
        var data = [];
        d.data.forEach(function(r) {
          data.push({
            text: r.name+" "+r.title,
            value: r.id
          });
        });
        vm.repairerPicker.setData(data);
      }
    });

    _callAjax({
      cmd: "fetch",
      sql: "select * from serviceInfo"
    }, function(d) {
      if (d.success && d.data && d.data.length) {
        var data = [];
        d.data.forEach(function(r) {
          data.push({
            text: r.name,
            value: r.price + "|" + r.id
          });
        });
        vm.servicePicker.setData(data);
      }
    });
  });
}());
