(function() {
  var vm = new Vue({
    el: "body",
    data: {
      months: null,
      area: null,
      location: null,
      channel: null,
      paySolgan: "请填写完整信息",
    },
    methods: {
      checkParams: function() {
        var months = parseInt(_trim(""+this.months)),
          area = parseInt(_trim(""+this.area));

        if (!months) {
          this.paySolgan = "请填写完整信息";
          return false;
        }
        if (!area) {
          this.paySolgan = "请填写完整信息";
          return false;
        }

        this.paySolgan = "共计"+(((area>100)?((area-100)*4+400):400)*months)+"元整";
        return true;
      },
      createOrder: function() {
        var months = parseInt(_trim(""+this.months)),
          area = parseInt(_trim(""+this.area)),
          location = _trim(""+this.location);

        if (!months) return mui.toast("请输入月数");
        if (!area) return mui.toast("请输入面积");
        if (!location) return mui.toast("请输入地址");
        if (!this.channel) return mui.toast("没有支付渠道");

        plus.storage.setItem("location", this.location);

        var self = this;
				_payAjax({}, function(d) {
					if(!d.success || !d.data) return;
          var price = ((area>100)?((area-100)*4+400):400)*months;
					var params = {
						total: price,
						show_url: "http://develop.wifizs.cn:10017/record.html",
						notify_url: "http://develop.wifizs.cn:10017/record.html",
						order_no: d.data
					};
					var appendix = _map(Object.keys(params), function(k) {
						return k + "=" + params[k];
					});
					mui_pay(
						self.channel,
						encodeURI("http://www.xinlantech.com/pay/index.php" + "?" + appendix.join("&")),
						function() {
							_callAjax({
								cmd: "transaction",
								sqls: JSON.stringify([
									"insert into record(order_no, amount, if_success) " +
									"values('" + d.data + "', " + price + ", 1)",
									"insert into repairRecord(userPhone, address, serviceId, price, content, repairerId)" +
									"values('" + plus.storage.getItem("phone") + "', '" +
									self.location + "', " + self.service.id + ", " + price +", '"+JSON.stringify({
                    months: months,
                    area: area
                  })+"', '')"
								])
							}, function(d) {
                // 发送短信
                _smsAjax({
                  cmd: "raw",
                  text: "【新蓝广科】有新的周期保洁订单，请登录管理网站查看",
                  phone: "15381352702"
                }, function(_d) {});
								mui.toast("支付成功");
                mui.back();
							});
						},
						function(e) {
							mui.toast("支付失败");
						}
					);
				})
      }
    }
  });

  ["months", "area"].forEach(function(k) {
    vm.$watch(k, vm.checkParams);
  });

  mui.back = function() {
    mui.fire(plus.webview.getWebviewById("record.html"), "fetchRecords", null);
    plus.webview.close(plus.webview.currentWebview());
    plus.webview.close("housekeepDetail");
    var index = plus.webview.getLaunchWebview();
    mui.fire(
      index,
      "gohome",
      {
        target: "records"
      }
    );
    plus.webview.show(index);
  };

  mui.plusReady(function() {
    // 获取服务详情
		vm.service = plus.webview.currentWebview().service;

    // 获取住址
    vm.location = plus.storage.getItem("location");

		// 获取支付渠道
		plus.payment.getChannels(function(channels) {
			channels.forEach(function(r) {
				if(r.id == "alipay") {
					vm.channel = r;
				}
			})
		}, function(e) {
			mui.toast("无法获取支付渠道");
		});
  });

}());
