(function() {
  var vm = new Vue({
    el: "body",
    data: {
      location: null,
      week: _oneWeek(),
      area: null,
      paySolgan: "请填写完整信息",
      timeSolgan: "请选择清理时段",
      channel: null
    },
    computed: {
      date: function() {
        return this.week.filter(function(r) {
          return r.ifChosen;
        })[0];
      }
    },
    methods: {
      cancelServiceTime: function() {
        this.week.forEach(function(r) {
          r.ifChosen = false;
        });
        $(".service-time").hide();
      },
      chooseServiceTime: function() {
        // this.week[index].ifChosen = true;
        if (!!this.date) {
          this.timeSolgan = this.date.date+"("+this.date.day+")";
        }
        $(".service-time").hide();
      },
      createOrder: function() {
        var location = _trim(this.location),
          area = parseInt(_trim(""+this.area));

        if (!location) return mui.toast("请填写住址");
        if (!area) return mui.toast("请填写面积");
        if (!this.date) return mui.toast("请选择日期");
        if (!this.channel) return mui.toast("没有支付渠道");

        plus.storage.setItem("location", this.location);

        var self = this;
				_payAjax({}, function(d) {
					if(!d.success || !d.data) return;
          // var price = parseInt(self.times.filter(function(r) {return r.ifChosen}).length) * 40;
          var price = area * 6;
					var params = {
						total: price,
						show_url: "http://develop.wifizs.cn:10017/record.html",
						notify_url: "http://develop.wifizs.cn:10017/record.html",
						order_no: d.data
					};
					var appendix = _map(Object.keys(params), function(k) {
						return k + "=" + params[k];
					});
					mui_pay(
						self.channel,
						encodeURI("http://www.xinlantech.com/pay/index.php" + "?" + appendix.join("&")),
						function() {
							_callAjax({
								cmd: "transaction",
								sqls: JSON.stringify([
									"insert into record(order_no, amount, if_success) " +
									"values('" + d.data + "', " + price + ", 1)",
									"insert into repairRecord(userPhone, address, serviceId, price, content, repairerId)" +
									"values('" + plus.storage.getItem("phone") + "', '" +
									self.location + "', " + self.service.id + ", " + price +", '"+JSON.stringify({
                    date: self.date,
                    area: area
                  })+"', '')"
								])
							}, function(d) {
                // 发送短信
                _smsAjax({
                  cmd: "raw",
                  text: "【新蓝广科】有新的新居开荒订单，请登录管理网站查看",
                  phone: "15381352702"
                }, function(_d) {});
								mui.toast("支付成功");
                mui.back();
							});
						},
						function(e) {
							mui.toast("支付失败");
						}
					);
				})
      },
      chooseTime: function() {
        $(".service-time").toggle();
      },
      checkParam: function() {
        var location = _trim(this.location),
          area = parseInt(_trim(""+this.area));
        if (!area || !this.date || !location) {
          this.paySolgan = "请填写完整信息";
        } else {
          this.paySolgan = "共计"+(area * 6)+"元整";
        }
      }
    }
  });

  ["timeSolgan", "area"].forEach(function(k) {
    vm.$watch(k, vm.checkParam);
  });

  mui.back = function() {
    mui.fire(plus.webview.getWebviewById("record.html"), "fetchRecords", null);
    plus.webview.close(plus.webview.currentWebview());
    plus.webview.close("housekeepDetail");
    var index = plus.webview.getLaunchWebview();
    mui.fire(
      index,
      "gohome",
      {
        target: "records"
      }
    );
    plus.webview.show(index);
  };

  mui.plusReady(function() {
    // 获取服务详情
		vm.service = plus.webview.currentWebview().service;

    // 获取住址
    vm.location = plus.storage.getItem("location");

		// 获取支付渠道
		plus.payment.getChannels(function(channels) {
			channels.forEach(function(r) {
				if(r.id == "alipay") {
					vm.channel = r;
				}
			})
		}, function(e) {
			mui.toast("无法获取支付渠道");
		});
  });

}());
