(function() {
  var vm = new Vue({
    el: "body",
    data: {
      service: null,
      channel: null,
      timeSolgan: "请选择清理时段",
      paySolgan: "请填写完整信息",
      week: _oneWeek(),
      location: null,
      times: [
        {
          text: "8:00-9:00",
          ifChosen: false
        },
        {
          text: "9:00-10:00",
          ifChosen: false
        },
        {
          text: "10:00-11:00",
          ifChosen: false
        },
        {
          text: "11:00-12:00",
          ifChosen: false
        },
        {
          text: "14:00-15:00",
          ifChosen: false
        },
        {
          text: "15:00-16:00",
          ifChosen: false
        }
      ]
    },
    computed: {
      choosenDate: function() {
        return this.week.filter(function(r) {
          return r.ifChosen
        })[0];
      },
      choosenTime: function() {
        return this.times.filter(function(r) {
          return r.ifChosen;
        });
      }
    },
    methods: {
      chooseTime: function() {
        $(".service-time").toggle();
      },
      cancelServiceTime: function() {
        this.week.forEach(function(r) {
          r.ifChosen = false;
        });
        this.times.forEach(function(r) {
          r.ifChosen = false;
        });
        this.timeSolgan = "请选择清理时段";
        this.paySolgan = "请填写完整信息";
        $(".service-time").hide();
      },
      chooseWeekDay:  function(id) {
        for(var i=0; i<this.week.length; i+=1) {
          this.week[i].ifChosen = (i==id);
        }
        this.times.forEach(function(r) {
          r.ifChosen = false;
        });
      },
      chooseServiceTime: function() {
        // var weekDay = this.week.filter(function(r) {
        //   return r.ifChosen;
        // })[0];
        // if (!weekDay) return mui.toast("请选择日期");
        if (!this.choosenDate) return mui.toast("请选择日期");
        // var times = this.times.filter(function(r) {
        //   return r.ifChosen;
        // });
        // if (!times.length) return mui.toast("请选择时段");
        if (!this.choosenTime.length) return mui.toast("请选择时段");
        this.timeSolgan = this.choosenDate.day+"("+this.chooseTime.length+"个小时)";
        this.paySolgan = "共计"+(this.choosenTime.length * 40)+"元整";
        $(".service-time").hide();
      },
      createOrder: function() {
        if (this.paySolgan == "请填写完整信息") return mui.toast("请选择时段");
        if (!this.location) return mui.toast("请填写住址");
        plus.storage.setItem("location", this.location);
        if (!this.channel) return mui.toast("没有支付渠道");

        var self = this;
				_payAjax({}, function(d) {
					if(!d.success || !d.data) return;
          var price = self.choosenTime.length * 40;
          // var price = 0.01;
					var params = {
						total: price,
						show_url: "http://develop.wifizs.cn:10017/record.html",
						notify_url: "http://develop.wifizs.cn:10017/record.html",
						order_no: d.data
					};
					var appendix = _map(Object.keys(params), function(k) {
						return k + "=" + params[k];
					});
					mui_pay(
						self.channel,
						encodeURI("http://www.xinlantech.com/pay/index.php" + "?" + appendix.join("&")),
						function() {
							_callAjax({
								cmd: "transaction",
								sqls: JSON.stringify([
									"insert into record(order_no, amount, if_success) " +
									"values('" + d.data + "', " + price + ", 1)",
									"insert into repairRecord(userPhone, address, serviceId, price, content, repairerId)" +
									"values('" + plus.storage.getItem("phone") + "', '" +
									self.location + "', " + self.service.id + ", " + price +", '"+JSON.stringify({
                    date: self.choosenDate,
                    times: self.choosenTime
                  })+"', '')"
								])
							}, function(d) {
                // 发送短信
                _smsAjax({
                  cmd: "raw",
                  text: "【新蓝广科】有新的玻璃清洗订单，请登录管理网站查看",
                  phone: "15381352702"
                }, function(_d) {});
								mui.toast("支付成功");
                mui.back();
							});
						},
						function(e) {
							mui.toast("支付失败");
						}
					);
				})
      }
    }
  });

  // var old = mui.back;
  mui.back = function() {
    mui.fire(plus.webview.getWebviewById("record.html"), "fetchRecords", null);
    plus.webview.close(plus.webview.currentWebview());
    plus.webview.close("housekeepDetail");
    var index = plus.webview.getLaunchWebview();
    mui.fire(
      index,
      "gohome",
      {
        target: "records"
      }
    );
    plus.webview.show(index);
  };

  mui.plusReady(function() {
    // 获取服务详情
		vm.service = plus.webview.currentWebview().service;

    // 获取住址
    vm.location = plus.storage.getItem("location");

		// 获取支付渠道
		plus.payment.getChannels(function(channels) {
			channels.forEach(function(r) {
				if(r.id == "alipay") {
					vm.channel = r;
				}
			})
		}, function(e) {
			mui.toast("无法获取支付渠道");
		});
  });

}());
